Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_bg.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_bg.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_bg.ts	(revision 61868)
@@ -113,5 +113,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ca.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ca.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ca.ts	(revision 61868)
@@ -154,5 +154,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ca_VA.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ca_VA.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ca_VA.ts	(revision 61868)
@@ -159,5 +159,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_cs.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_cs.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_cs.ts	(revision 61868)
@@ -158,5 +158,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_da.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_da.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_da.ts	(revision 61868)
@@ -116,5 +116,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts	(revision 61868)
@@ -90,5 +90,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_el.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_el.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_el.ts	(revision 61868)
@@ -90,5 +90,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_es.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_es.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_es.ts	(revision 61868)
@@ -166,5 +166,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_eu.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_eu.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_eu.ts	(revision 61868)
@@ -109,5 +109,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <location filename="../src/extensions/QIArrowButtonPress.cpp" line="+45"/>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fa_IR.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fa_IR.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fa_IR.ts	(revision 61868)
@@ -90,5 +90,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fi.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fi.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fi.ts	(revision 61868)
@@ -143,5 +143,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fr.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fr.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fr.ts	(revision 61868)
@@ -98,5 +98,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_gl_ES.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_gl_ES.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_gl_ES.ts	(revision 61868)
@@ -113,5 +113,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_hu.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_hu.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_hu.ts	(revision 61868)
@@ -155,5 +155,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_id.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_id.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_id.ts	(revision 61868)
@@ -146,5 +146,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_it.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_it.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_it.ts	(revision 61868)
@@ -158,5 +158,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ja.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ja.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ja.ts	(revision 61868)
@@ -158,5 +158,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_km_KH.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_km_KH.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_km_KH.ts	(revision 61868)
@@ -94,5 +94,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ko.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ko.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ko.ts	(revision 61868)
@@ -117,5 +117,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_lt.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_lt.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_lt.ts	(revision 61868)
@@ -94,5 +94,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_nl.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_nl.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_nl.ts	(revision 61868)
@@ -95,5 +95,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pl.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pl.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pl.ts	(revision 61868)
@@ -154,5 +154,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt.ts	(revision 61868)
@@ -150,5 +150,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt_BR.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt_BR.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt_BR.ts	(revision 61868)
@@ -154,5 +154,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ro.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ro.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ro.ts	(revision 61868)
@@ -158,5 +158,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts	(revision 61868)
@@ -117,5 +117,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sk.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sk.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sk.ts	(revision 61868)
@@ -150,5 +150,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sr.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sr.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sr.ts	(revision 61868)
@@ -113,5 +113,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sv.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sv.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sv.ts	(revision 61868)
@@ -128,5 +128,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_tr.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_tr.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_tr.ts	(revision 61868)
@@ -150,5 +150,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_uk.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_uk.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_uk.ts	(revision 61868)
@@ -113,5 +113,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_xx_YY.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_xx_YY.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_xx_YY.ts	(revision 61868)
@@ -90,5 +90,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_CN.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_CN.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_CN.ts	(revision 61868)
@@ -94,5 +94,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_TW.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_TW.ts	(revision 61819)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_TW.ts	(revision 61868)
@@ -90,5 +90,5 @@
 </context>
 <context>
-    <name>QIArrowSplitter</name>
+    <name>QIArrowButtonPress</name>
     <message>
         <source>&amp;Back</source>