Index: /trunk/include/iprt/json.h
===================================================================
--- /trunk/include/iprt/json.h	(revision 62020)
+++ /trunk/include/iprt/json.h	(revision 62021)
@@ -154,8 +154,6 @@
  * @param   hJsonVal        The JSON value handle.
  * @param   ppszStr         Where to store the pointer to the string on success.
- * @todo r=bird: Rename to RTJsonValueQueryString as getters returns values
- *               not status codes (see guidelines).
- */
-RTDECL(int) RTJsonValueGetStringEx(RTJSONVAL hJsonVal, const char **ppszStr);
+ */
+RTDECL(int) RTJsonValueQueryString(RTJSONVAL hJsonVal, const char **ppszStr);
 
 /**
@@ -170,10 +168,6 @@
  *          numbers currently.  When it does, it will be in the form of a
  *          RTJsonValueQueryFloat method.
- *
- * @todo r=bird: Rename to RTJsonValueQueryInteger as getters returns values
- *               not status codes (see guidelines), and "Integer" is better for
- *               future floating point support.
- */
-RTDECL(int) RTJsonValueGetNumber(RTJSONVAL hJsonVal, int64_t *pi64Num);
+ */
+RTDECL(int) RTJsonValueQueryInteger(RTJSONVAL hJsonVal, int64_t *pi64Num);
 
 /**
@@ -186,8 +180,6 @@
  * @param   pszName         The member name of the object.
  * @param   phJsonVal       Where to store the handle to the JSON value on success.
- * @todo r=bird: Rename to RTJsonValueQueryByName as getters returns
- *               values not status codes (see guidelines).
- */
-RTDECL(int) RTJsonValueGetByName(RTJSONVAL hJsonVal, const char *pszName, PRTJSONVAL phJsonVal);
+ */
+RTDECL(int) RTJsonValueQueryByName(RTJSONVAL hJsonVal, const char *pszName, PRTJSONVAL phJsonVal);
 
 /**
@@ -201,8 +193,6 @@
  * @param   pszName         The member name of the object.
  * @param   pi64Num         Where to store the number on success.
- * @todo r=bird: Rename to RTJsonValueQueryNumberByName as getters returns
- *               values not status codes (see guidelines).
- */
-RTDECL(int) RTJsonValueGetNumberByName(RTJSONVAL hJsonVal, const char *pszName, int64_t *pi64Num);
+ */
+RTDECL(int) RTJsonValueQueryIntegerByName(RTJSONVAL hJsonVal, const char *pszName, int64_t *pi64Num);
 
 /**
@@ -217,8 +207,6 @@
  * @param   ppszStr         Where to store the pointer to the string on success.
  *                          Must be freed with RTStrFree().
- * @todo r=bird: Rename to RTJsonValueQueryStringByName as getters returns
- *               values not status codes (see guidelines).
- */
-RTDECL(int) RTJsonValueGetStringByName(RTJSONVAL hJsonVal, const char *pszName, char **ppszStr);
+ */
+RTDECL(int) RTJsonValueQueryStringByName(RTJSONVAL hJsonVal, const char *pszName, char **ppszStr);
 
 /**
@@ -232,8 +220,6 @@
  * @param   pszName         The member name of the object.
  * @param   pfBoolean       Where to store the boolean value on success.
- * @todo r=bird: Rename to RTJsonValueQueryBooleanByName as getters returns
- *               values not status codes (see guidelines).
- */
-RTDECL(int) RTJsonValueGetBooleanByName(RTJSONVAL hJsonVal, const char *pszName, bool *pfBoolean);
+ */
+RTDECL(int) RTJsonValueQueryBooleanByName(RTJSONVAL hJsonVal, const char *pszName, bool *pfBoolean);
 
 /**
@@ -253,10 +239,6 @@
  * @param   hJsonVal        The JSON value handle.
  * @param   pcItems         Where to store the size of the JSON array value on success.
- * @todo r=bird: Rename to RTJsonValueQueryArraySize as getters returns
- *               values not status codes (see guidelines).
- *               Implementation is using 'uint32_t' not 'unsigned', goes for the
- *               other functions here.
- */
-RTDECL(int) RTJsonValueGetArraySizeEx(RTJSONVAL hJsonVal, unsigned *pcItems);
+ */
+RTDECL(int) RTJsonValueQueryArraySize(RTJSONVAL hJsonVal, unsigned *pcItems);
 
 /**
@@ -270,8 +252,6 @@
  * @param   idx             The index to get the value from.
  * @param   phJsonVal       Where to store the handle to the JSON value on success.
- * @todo r=bird: Rename to RTJsonValueQueryByIndex as getters returns
- *               values not status codes (see guidelines).
- */
-RTDECL(int) RTJsonValueGetByIndex(RTJSONVAL hJsonVal, unsigned idx, PRTJSONVAL phJsonVal);
+ */
+RTDECL(int) RTJsonValueQueryByIndex(RTJSONVAL hJsonVal, unsigned idx, PRTJSONVAL phJsonVal);
 
 /**
@@ -294,8 +274,6 @@
  * @param   ppszName        Where to store the object member name for an object.
  *                          NULL is returned for arrays.
- * @todo r=bird: Rename to RTJsonIteratorQueryValue as getters returns
- *               values not status codes (see guidelines).
- */
-RTDECL(int) RTJsonIteratorGetValue(RTJSONIT hJsonIt, PRTJSONVAL phJsonVal, const char **ppszName);
+ */
+RTDECL(int) RTJsonIteratorQueryValue(RTJSONIT hJsonIt, PRTJSONVAL phJsonVal, const char **ppszName);
 
 /**
Index: /trunk/include/iprt/mangling.h
===================================================================
--- /trunk/include/iprt/mangling.h	(revision 62020)
+++ /trunk/include/iprt/mangling.h	(revision 62021)
@@ -955,20 +955,20 @@
 # define RTJsonIteratorBegin                            RT_MANGLER(RTJsonIteratorBegin)
 # define RTJsonIteratorFree                             RT_MANGLER(RTJsonIteratorFree)
-# define RTJsonIteratorGetValue                         RT_MANGLER(RTJsonIteratorGetValue)
 # define RTJsonIteratorNext                             RT_MANGLER(RTJsonIteratorNext)
+# define RTJsonIteratorQueryValue                       RT_MANGLER(RTJsonIteratorQueryValue)
 # define RTJsonParseFromBuf                             RT_MANGLER(RTJsonParseFromBuf)
 # define RTJsonParseFromFile                            RT_MANGLER(RTJsonParseFromFile)
 # define RTJsonParseFromString                          RT_MANGLER(RTJsonParseFromString)
 # define RTJsonValueGetArraySize                        RT_MANGLER(RTJsonValueGetArraySize)
-# define RTJsonValueGetArraySizeEx                      RT_MANGLER(RTJsonValueGetArraySizeEx)
-# define RTJsonValueGetBooleanByName                    RT_MANGLER(RTJsonValueGetBooleanByName)
-# define RTJsonValueGetByIndex                          RT_MANGLER(RTJsonValueGetByIndex)
-# define RTJsonValueGetByName                           RT_MANGLER(RTJsonValueGetByName)
-# define RTJsonValueGetNumber                           RT_MANGLER(RTJsonValueGetNumber)
-# define RTJsonValueGetNumberByName                     RT_MANGLER(RTJsonValueGetNumberByName)
 # define RTJsonValueGetString                           RT_MANGLER(RTJsonValueGetString)
-# define RTJsonValueGetStringByName                     RT_MANGLER(RTJsonValueGetStringByName)
-# define RTJsonValueGetStringEx                         RT_MANGLER(RTJsonValueGetStringEx)
 # define RTJsonValueGetType                             RT_MANGLER(RTJsonValueGetType)
+# define RTJsonValueQueryArraySizeEx                    RT_MANGLER(RTJsonValueQueryArraySize)
+# define RTJsonValueQueryBooleanByName                  RT_MANGLER(RTJsonValueQueryBooleanByName)
+# define RTJsonValueQueryByIndex                        RT_MANGLER(RTJsonValueQueryByIndex)
+# define RTJsonValueQueryByName                         RT_MANGLER(RTJsonValueQueryByName)
+# define RTJsonValueQueryInteger                        RT_MANGLER(RTJsonValueQueryInteger)
+# define RTJsonValueQueryIntegerByName                  RT_MANGLER(RTJsonValueQueryIntegerByName)
+# define RTJsonValueQueryString                         RT_MANGLER(RTJsonValueQueryString)
+# define RTJsonValueQueryStringByName                   RT_MANGLER(RTJsonValueQueryStringByName)
 # define RTJsonValueRelease                             RT_MANGLER(RTJsonValueRelease)
 # define RTJsonValueRetain                              RT_MANGLER(RTJsonValueRetain)
Index: /trunk/src/VBox/Runtime/common/misc/json.cpp
===================================================================
--- /trunk/src/VBox/Runtime/common/misc/json.cpp	(revision 62020)
+++ /trunk/src/VBox/Runtime/common/misc/json.cpp	(revision 62021)
@@ -201,5 +201,5 @@
         {
             /** Number of elements in the array. */
-            uint32_t        cItems;
+            unsigned        cItems;
             /** Pointer to the array of items. */
             PRTJSONVALINT   *papItems;
@@ -209,5 +209,5 @@
         {
             /** Number of members. */
-            uint32_t        cMembers;
+            unsigned        cMembers;
             /** Pointer to the array holding the member names. */
             char            **papszNames;
@@ -1264,5 +1264,5 @@
 }
 
-RTDECL(int) RTJsonValueGetStringEx(RTJSONVAL hJsonVal, const char **ppszStr)
+RTDECL(int) RTJsonValueQueryString(RTJSONVAL hJsonVal, const char **ppszStr)
 {
     PRTJSONVALINT pThis = hJsonVal;
@@ -1275,5 +1275,5 @@
 }
 
-RTDECL(int) RTJsonValueGetNumber(RTJSONVAL hJsonVal, int64_t *pi64Num)
+RTDECL(int) RTJsonValueQueryInteger(RTJSONVAL hJsonVal, int64_t *pi64Num)
 {
     PRTJSONVALINT pThis = hJsonVal;
@@ -1286,5 +1286,5 @@
 }
 
-RTDECL(int) RTJsonValueGetByName(RTJSONVAL hJsonVal, const char *pszName, PRTJSONVAL phJsonVal)
+RTDECL(int) RTJsonValueQueryByName(RTJSONVAL hJsonVal, const char *pszName, PRTJSONVAL phJsonVal)
 {
     PRTJSONVALINT pThis = hJsonVal;
@@ -1309,11 +1309,11 @@
 }
 
-RTDECL(int) RTJsonValueGetNumberByName(RTJSONVAL hJsonVal, const char *pszName, int64_t *pi64Num)
+RTDECL(int) RTJsonValueQueryIntegerByName(RTJSONVAL hJsonVal, const char *pszName, int64_t *pi64Num)
 {
     RTJSONVAL hJsonValNum = NIL_RTJSONVAL;
-    int rc = RTJsonValueGetByName(hJsonVal, pszName, &hJsonValNum);
+    int rc = RTJsonValueQueryByName(hJsonVal, pszName, &hJsonValNum);
     if (RT_SUCCESS(rc))
     {
-        rc = RTJsonValueGetNumber(hJsonValNum, pi64Num);
+        rc = RTJsonValueQueryInteger(hJsonValNum, pi64Num);
         RTJsonValueRelease(hJsonValNum);
     }
@@ -1322,12 +1322,12 @@
 }
 
-RTDECL(int) RTJsonValueGetStringByName(RTJSONVAL hJsonVal, const char *pszName, char **ppszStr)
+RTDECL(int) RTJsonValueQueryStringByName(RTJSONVAL hJsonVal, const char *pszName, char **ppszStr)
 {
     RTJSONVAL hJsonValStr = NIL_RTJSONVAL;
-    int rc = RTJsonValueGetByName(hJsonVal, pszName, &hJsonValStr);
+    int rc = RTJsonValueQueryByName(hJsonVal, pszName, &hJsonValStr);
     if (RT_SUCCESS(rc))
     {
         const char *pszStr = NULL;
-        rc = RTJsonValueGetStringEx(hJsonValStr, &pszStr);
+        rc = RTJsonValueQueryString(hJsonValStr, &pszStr);
         if (RT_SUCCESS(rc))
         {
@@ -1342,10 +1342,10 @@
 }
 
-RTDECL(int) RTJsonValueGetBooleanByName(RTJSONVAL hJsonVal, const char *pszName, bool *pfBoolean)
+RTDECL(int) RTJsonValueQueryBooleanByName(RTJSONVAL hJsonVal, const char *pszName, bool *pfBoolean)
 {
     AssertPtrReturn(pfBoolean, VERR_INVALID_POINTER);
 
     RTJSONVAL hJsonValBool = NIL_RTJSONVAL;
-    int rc = RTJsonValueGetByName(hJsonVal, pszName, &hJsonValBool);
+    int rc = RTJsonValueQueryByName(hJsonVal, pszName, &hJsonValBool);
     if (RT_SUCCESS(rc))
     {
@@ -1363,5 +1363,5 @@
 }
 
-RTDECL(uint32_t) RTJsonValueGetArraySize(RTJSONVAL hJsonVal)
+RTDECL(unsigned) RTJsonValueGetArraySize(RTJSONVAL hJsonVal)
 {
     PRTJSONVALINT pThis = hJsonVal;
@@ -1372,5 +1372,5 @@
 }
 
-RTDECL(int) RTJsonValueGetArraySizeEx(RTJSONVAL hJsonVal, uint32_t *pcItems)
+RTDECL(int) RTJsonValueQueryArraySize(RTJSONVAL hJsonVal, unsigned *pcItems)
 {
     PRTJSONVALINT pThis = hJsonVal;
@@ -1383,5 +1383,5 @@
 }
 
-RTDECL(int) RTJsonValueGetByIndex(RTJSONVAL hJsonVal, uint32_t idx, PRTJSONVAL phJsonVal)
+RTDECL(int) RTJsonValueQueryByIndex(RTJSONVAL hJsonVal, unsigned idx, PRTJSONVAL phJsonVal)
 {
     PRTJSONVALINT pThis = hJsonVal;
@@ -1416,5 +1416,5 @@
 }
 
-RTDECL(int) RTJsonIteratorGetValue(RTJSONIT hJsonIt, PRTJSONVAL phJsonVal, const char **ppszName)
+RTDECL(int) RTJsonIteratorQueryValue(RTJSONIT hJsonIt, PRTJSONVAL phJsonVal, const char **ppszName)
 {
     PRTJSONITINT pIt = hJsonIt;
Index: /trunk/src/VBox/Runtime/testcase/tstRTJson.cpp
===================================================================
--- /trunk/src/VBox/Runtime/testcase/tstRTJson.cpp	(revision 62020)
+++ /trunk/src/VBox/Runtime/testcase/tstRTJson.cpp	(revision 62021)
@@ -101,5 +101,5 @@
 static void tstCorrectnessRcForInvalidType(RTTEST hTest, RTJSONVAL hJsonVal, RTJSONVALTYPE enmType)
 {
-#if 0 /* Enable manually or it will assert all over the place for debug builds. */
+#ifndef RT_STRICT /* Enable manually if assertions are enabled or it will assert all over the place for debug builds. */
     if (   enmType != RTJSONVALTYPE_OBJECT
         && enmType != RTJSONVALTYPE_ARRAY)
@@ -116,6 +116,6 @@
         RTJSONVAL hJsonValItem = NIL_RTJSONVAL;
         RTTEST_CHECK(hTest, RTJsonValueGetArraySize(hJsonVal) == 0);
-        RTTEST_CHECK_RC(hTest, RTJsonValueGetArraySizeEx(hJsonVal, &cItems), VERR_JSON_VALUE_INVALID_TYPE);
-        RTTEST_CHECK_RC(hTest, RTJsonValueGetByIndex(hJsonVal, 0, &hJsonValItem), VERR_JSON_VALUE_INVALID_TYPE);
+        RTTEST_CHECK_RC(hTest, RTJsonValueQueryArraySize(hJsonVal, &cItems), VERR_JSON_VALUE_INVALID_TYPE);
+        RTTEST_CHECK_RC(hTest, RTJsonValueQueryByIndex(hJsonVal, 0, &hJsonValItem), VERR_JSON_VALUE_INVALID_TYPE);
     }
 
@@ -124,5 +124,5 @@
         /* The object access methods should return errors. */
         RTJSONVAL hJsonValMember = NIL_RTJSONVAL;
-        RTTEST_CHECK_RC(hTest, RTJsonValueGetByName(hJsonVal, "test", &hJsonValMember), VERR_JSON_VALUE_INVALID_TYPE);
+        RTTEST_CHECK_RC(hTest, RTJsonValueQueryByName(hJsonVal, "test", &hJsonValMember), VERR_JSON_VALUE_INVALID_TYPE);
     }
 
@@ -130,5 +130,5 @@
     {
         int64_t i64Num = 0;
-        RTTEST_CHECK_RC(hTest, RTJsonValueGetNumber(hJsonVal, &i64Num), VERR_JSON_VALUE_INVALID_TYPE);
+        RTTEST_CHECK_RC(hTest, RTJsonValueQueryInteger(hJsonVal, &i64Num), VERR_JSON_VALUE_INVALID_TYPE);
     }
 
@@ -137,5 +137,5 @@
         const char *psz = NULL;
         RTTEST_CHECK(hTest, RTJsonValueGetString(hJsonVal) == NULL);
-        RTTEST_CHECK_RC(hTest, RTJsonValueGetStringEx(hJsonVal, &psz), VERR_JSON_VALUE_INVALID_TYPE);
+        RTTEST_CHECK_RC(hTest, RTJsonValueQueryString(hJsonVal, &psz), VERR_JSON_VALUE_INVALID_TYPE);
     }
 #endif
@@ -149,5 +149,6 @@
     uint32_t cItems = 0;
     RTTEST_CHECK(hTest, RTJsonValueGetArraySize(hJsonVal) == 6);
-    RTTEST_CHECK_RC_OK(hTest, RTJsonValueGetArraySizeEx(hJsonVal, &cItems));
+    RTTEST_CHECK_RC_OK(hTest, RTJsonValueQueryArraySize(hJsonVal, &cItems));
+    RTTEST_CHECK(hTest, cItems == RTJsonValueGetArraySize(hJsonVal));
 
     for (uint32_t i = 1; i <= 5; i++)
@@ -155,7 +156,7 @@
         int64_t i64Num = 0;
         RTJSONVAL hJsonValItem = NIL_RTJSONVAL;
-        RTTEST_CHECK_RC_OK_RETV(hTest, RTJsonValueGetByIndex(hJsonVal, i - 1, &hJsonValItem));
+        RTTEST_CHECK_RC_OK_RETV(hTest, RTJsonValueQueryByIndex(hJsonVal, i - 1, &hJsonValItem));
         RTTEST_CHECK(hTest, RTJsonValueGetType(hJsonValItem) == RTJSONVALTYPE_NUMBER);
-        RTTEST_CHECK_RC_OK_RETV(hTest, RTJsonValueGetNumber(hJsonValItem, &i64Num));
+        RTTEST_CHECK_RC_OK_RETV(hTest, RTJsonValueQueryInteger(hJsonValItem, &i64Num));
         RTTEST_CHECK(hTest, i64Num == (int64_t)i);
         RTTEST_CHECK(hTest, RTJsonValueRelease(hJsonValItem) == 1);
@@ -165,7 +166,7 @@
     const char *pszStr = NULL;
     RTJSONVAL hJsonValItem = NIL_RTJSONVAL;
-    RTTEST_CHECK_RC_OK_RETV(hTest, RTJsonValueGetByIndex(hJsonVal, 5, &hJsonValItem));
+    RTTEST_CHECK_RC_OK_RETV(hTest, RTJsonValueQueryByIndex(hJsonVal, 5, &hJsonValItem));
     RTTEST_CHECK(hTest, RTJsonValueGetType(hJsonValItem) == RTJSONVALTYPE_STRING);
-    RTTEST_CHECK_RC_OK_RETV(hTest, RTJsonValueGetStringEx(hJsonValItem, &pszStr));
+    RTTEST_CHECK_RC_OK_RETV(hTest, RTJsonValueQueryString(hJsonValItem, &pszStr));
     RTTEST_CHECK(hTest, RTJsonValueGetString(hJsonValItem) == pszStr);
     RTTEST_CHECK(hTest, strcmp(pszStr, "6") == 0);
@@ -185,5 +186,5 @@
         const char *pszName = NULL;
         RTJSONVAL hJsonValMember = NIL_RTJSONVAL;
-        rc = RTJsonIteratorGetValue(hJsonIt, &hJsonValMember, &pszName);
+        rc = RTJsonIteratorQueryValue(hJsonIt, &hJsonValMember, &pszName);
         RTTEST_CHECK(hTest, RT_SUCCESS(rc));
         RTTEST_CHECK(hTest, pszName != NULL);
@@ -208,5 +209,5 @@
                     RTTEST_CHECK(hTest, strcmp(pszName, "string") == 0);
                     const char *pszStr = NULL;
-                    RTTEST_CHECK_RC_OK(hTest, RTJsonValueGetStringEx(hJsonValMember, &pszStr));
+                    RTTEST_CHECK_RC_OK(hTest, RTJsonValueQueryString(hJsonValMember, &pszStr));
                     RTTEST_CHECK(hTest, strcmp(pszStr, "test") == 0);
                     break;
@@ -216,5 +217,5 @@
                     RTTEST_CHECK(hTest, strcmp(pszName, "number") == 0);
                     int64_t i64Num = 0;
-                    RTTEST_CHECK_RC_OK(hTest, RTJsonValueGetNumber(hJsonValMember, &i64Num));
+                    RTTEST_CHECK_RC_OK(hTest, RTJsonValueQueryInteger(hJsonValMember, &i64Num));
                     RTTEST_CHECK(hTest, i64Num == 100);
                     break;
@@ -237,5 +238,5 @@
             RTTEST_CHECK(hTest, rc == VINF_SUCCESS || rc == VERR_JSON_ITERATOR_END);
             if (RT_SUCCESS(rc))
-                RTTEST_CHECK_RC_OK(hTest, RTJsonIteratorGetValue(hJsonIt, &hJsonValMember, &pszName));
+                RTTEST_CHECK_RC_OK(hTest, RTJsonIteratorQueryValue(hJsonIt, &hJsonValMember, &pszName));
         }
         RTJsonIteratorFree(hJsonIt);